DATA_LENGTH     equ     512
;--------------------------------------------------------------
;     Floppy I/O , memXfer Library  
;--------------------------------------------------------------
        Title   dskbio14.s
                .186
                .MODEL  small,C
.data
extern          _DiskBuf:DWORD  ; ( byte pointer far)
extern          _DAUA:WORD

FATbuf          label DWORD
FATbufOfs       DW      0000h
FATbufSeg       DW      8000h
CylNumber       DB      77
HeadNumber      DB      0
CHRN8S          label   byte
                DB      0,0,1,0
                DB      0,0,2,0
                DB      0,0,3,0
                DB      0,0,4,0
                DB      0,0,5,0
                DB      0,0,6,0
                DB      0,0,7,0
                DB      0,0,8,0
FillDataFAT     label byte
 DB  00h, 00h, 00h, 00h, 00h, 00h, 00h, 00h, 00h, 00h, 00h, 00h, 00h, 00h, 00h, 00h
 DB  00h, 00h, 00h, 00h, 00h, 00h, 00h, 00h, 00h, 00h, 00h, 00h, 00h, 00h, 00h, 00h
 DB  00h, 00h, 00h, 00h, 00h, 00h, 00h, 00h, 00h, 00h
FillDataFAT_Base  label byte
 DB                                                    70h,0FFh,0F7h, 7Fh,0FFh,0F7h
 DB  7Fh,0FFh,0F7h, 7Fh,0FFh,0F7h, 7Fh,0FFh,0F7h, 7Fh,0FFh,0F7h, 7Fh,0FFh,0F7h, 7Fh
 DB 0FFh,0F7h, 7Fh,0FFh,0F7h, 7Fh,0FFh,0F7h, 7Fh,0FFh,0F7h, 7Fh,0FFh,0F7h, 7Fh,0FFh
 DB 0F7h, 7Fh,0FFh,0F7h, 7Fh,0FFh,0F7h, 7Fh,0FFh,0F7h, 7Fh,0FFh,0F7h, 7Fh,0FFh,0F7h
 DB  7Fh,0FFh,0F7h, 7Fh,0FFh,0F7h, 7Fh,0FFh,0F7h, 7Fh,0FFh,0F7h, 7Fh,0FFh,0F7h, 7Fh
 DB 0FFh,0F7h, 7Fh,0FFh,0F7h, 7Fh,0FFh,0F7h, 7Fh,0FFh,0F7h, 7Fh,0FFh,0F7h, 7Fh,0FFh
 DB 0F7h, 7Fh,0FFh,0F7h, 7Fh,0FFh,0F7h, 7Fh,0FFh,0F7h, 7Fh,0FFh,0F7h, 7Fh,0FFh,0F7h
 DB  7Fh,0FFh,0F7h, 7Fh,0FFh,0F7h, 7Fh,0FFh,0F7h, 7Fh,0FFh,0F7h, 7Fh,0FFh,0F7h, 7Fh
 DB 0FFh,0F7h, 7Fh,0FFh,0F7h, 7Fh,0FFh,0F7h, 7Fh,0FFh,0F7h, 7Fh,0FFh,0F7h, 7Fh,0FFh
 DB 0F7h, 7Fh,0FFh,0F7h, 7Fh,0FFh,0F7h, 7Fh,0FFh,0F7h, 7Fh,0FFh, 00h, 00h, 00h, 00h
 DB  00h, 00h, 00h, 00h, 00h, 00h, 00h, 00h, 00h, 00h, 00h, 00h, 00h, 00h, 00h, 00h
FillDataFAT_End label byte

.code
ModFAT_ES_DI_BX PROC   near
                mov     di,offset FillDataFAT_Base - offset FillDataFAT
                add     di,bx
                mov     cx,offset FillDataFAT_End - offset FillDataFAT_Base
                mov     si,offset FillDataFAT_Base
          rep   cmpsb
                jz      Cyl77_79_OK
                xor     ax,ax
                mov     di,offset FillDataFAT_Base - offset FillDataFAT
                add     di,bx
                mov     cx,offset FillDataFAT_End - offset FillDataFAT_Base
          repz  scasb
                or      cx,cx
                jnz     Cyl77_79_isUsed
                mov     di,bx
                mov     si,offset FillDataFAT
                mov     cx,0C0h/2
        rep     movsw
Cyl77_79_OK:
                mov     di,bx
                clc
                ret
Cyl77_79_isUsed:
                stc
                ret
ModFAT_ES_DI_BX ENDP
;-----------------------------------------------------------------------------
;       AllocateUnusedFAT_1440
;-----------------------------------------------------------------------------
AllocateUnusedFAT_1440  PROC   near
                push    es
                push    si
                push    di
                les     di,_DiskBuf
                add     di,0D000h
                mov     FATbufOfs,di
                mov     FATbufSeg,es

                push    bp
                mov     bp,di
                mov     bx,0200h  ; data len=512B
                mov     cx,0200h        ; sect len=512B/s, cyl 00
                mov     dx,000Ah        ; side00,sect0A !!!
                mov     ax,_DAUA
                and     al,00000011b
                or      ax,5630h        ; READ sector DA/UA 3xh
                int     1Bh
                pop     bp
                jc      ErrReadFAT

                mov     bx,di
                call    ModFAT_ES_DI_BX
                mov     ax,0FFFFh
                jc      ErrReadFAT
                mov     di,bx

                push    bp
                mov     bp,di
                ; FAT#2
                mov     bx,0200h        ; data len=512B
                mov     cx,0200h        ; sect len=512B/s, cyl 00
                mov     dx,0101h        ; side01,sect01 !!!
                mov     ax,_DAUA
                and     al,00000011b
                or      ax,5530h        ; READ sector DA/UA 3xh
                int     1Bh
                ; FAT#1
                mov     bx,0200h        ; data len=512B
                mov     cx,0200h        ; sect len=512B/s, cyl 00
                mov     dx,000Ah        ; side00,sect0A !!!
                mov     ax,_DAUA
                and     al,00000011b
                or      ax,5530h        ; READ sector DA/UA 3xh
                int     1Bh
                pop     bp
                jc      ErrReadFAT

                xor     ax,ax
                jmp     AllocateUnusedFAT_1440_End
ErrReadFAT:     shr     ax,8
                and     al,0F0h
AllocateUnusedFAT_1440_End:
                pop     di
                pop     si
                pop     es
                ret
AllocateUnusedFAT_1440  ENDP


;-----------------------------------------------------------------------------
;       ReadFDIPL_1440  IPL̃ZN^ǂݏo 1232KłƈقȂgbNSǂ
;-----------------------------------------------------------------------------
                PUBLIC  ReadFDIPL_1440
ReadFDIPL_1440  PROC   near     BufPtrR:WORD
                push    es
                push    si
                push    di
                push    bp
                les     bp,_DiskBuf
                mov     ax,_DAUA
                or      ax,0790h        ; recalibrate
                int     1Bh

                les     bp,_DiskBuf
                mov     bx,DATA_LENGTH  ; data len=512B~18=2400h
                mov     cx,0200h        ; sect len=512B/s, cyl 00
                mov     dx,0001h        ; side00,sect01 !!!
                mov     ax,_DAUA
                and     al,00000011b
                or      ax,5630h        ; READ sector DA/UA 3xh
                int     1Bh
                pop     bp
                jc      ErrReadFDIPL

                push    ds
                mov     ax,ds
                mov     es,ax
                mov     di,BufPtrR
                lds     si,_DiskBuf
                mov     cx,DATA_LENGTH/2        ; 512B~18=2400h=9216
        rep     movsw
                pop     ds
                xor     ax,ax
                jmp     EndReadFDIPL
ErrReadFDIPL:   shr     ax,8            ; error code
                and     al,0F0h 
EndReadFDIPL:
                pop     di
                pop     si
                pop     es
                ret
ReadFDIPL_1440  ENDP

;-----------------------------------------------------------------
;       ReadBuf_Cyl77_1440  
;-----------------------------------------------------------------
                PUBLIC  ReadBuf_Cyl77_1440  
ReadBuf_Cyl77_1440   PROC   near     Buf45k:WORD
                push    es
                push    si
                push    di
                
                mov     cs:DiskError,0
                mov     si,offset CHRN_base
               push    bp
                les     bp,_DiskBuf
                mov     cx,5            ; 5 blocks
load_CHRN_base: mov     bx,9216         ; len=9KB
                push    cx
                mov     cx,cs:[si]
                inc     si
                inc     si
                mov     dx,cs:[si]
                inc     si
                inc     si
                mov     ax,_DAUA
                and     al,00000011b
                or      ax,5630h        ; DA/UA =3xh
                int     1Bh
                JNC     NoDiskErrorR
                and     ah,0F0h
                cmp     ah,60h
                jne     @f
                mov     cs:DiskError,60h
        @@:
                inc     cs:DiskError       ; error counter
NoDiskErrorR:    
                pop     cx
                add     BP,9216 ; adrv 9KB
                loop    load_CHRN_base
               pop     bp
                xor     ax,ax           ; success
                cmp     cs:DiskError,0
                jne     ReadBuf_Cyl77_Err
                
                mov     di,Buf45k
                push    ds
                push    ds
                pop     es
                lds     si,_DiskBuf
                mov     cx,0B400h/2
        rep     movsw
                pop     ds
                xor     ax,ax
                jmp     ReadBuf_Cyl77_End
ReadBuf_Cyl77_Err:
                mov     ax,cs:DiskError ; fail
ReadBuf_Cyl77_End:
                pop     di
                pop     si
                pop     es
                ret
ReadBuf_Cyl77_1440   ENDP


;-----------------------------------------------------------------
;       WriteFDIPL_1440  IPL̃ZN^ɏ
;-----------------------------------------------------------------
                PUBLIC  WriteFDIPL_1440
WriteFDIPL_1440 PROC   near     BufPtrW7:WORD
                push    es
                push    si
                push    di

                mov     si,BufPtrW7
                les     di,_DiskBuf
                mov     cx,DATA_LENGTH/2
        rep     movsw

                push    bp
                les     bp,_DiskBuf
                mov     ax,_DAUA
                or      ax,0790h        ; recalibrate
                int     1Bh
                mov     bx,DATA_LENGTH  ; data len=512B~18=2400h
                mov     cx,0200h        ; sect len=512B/s, cyl00
                mov     dx,0001h        ; side00,sect01 !!!
                mov     ax,_DAUA
                and     al,00000011b
                or      ax,5530h        ; WRITE sector DA/UA 3xh
                int     1Bh
                pop     bp
                mov     ax,0
                jnc     @f
                shr     ax,8            ; error code
                and     al,0F0h
        @@:
                pop     di
                pop     si
                pop     es
                ret
WriteFDIPL_1440 ENDP

;-----------------------------------------------------------------
;       WriteBuf_Cyl77_1440  
;-----------------------------------------------------------------
                PUBLIC  WriteBuf_Cyl77_1440
WriteBuf_Cyl77_1440  PROC   near     Buf45K:WORD
                push    es
                push    si
                push    di

                mov     cs:DiskError,0
                mov     si,Buf45K
                les     di,_DiskBuf
                mov     cx,0B400h/2
        rep     movsw
        
                mov     si,offset CHRN_base
               push    bp
                les     bp,_DiskBuf
                mov     cx,5            ; 5 blocks
load_CHRN_base: mov     bx,9216         ; len=9KB
                push    cx
                mov     cx,cs:[si]
                inc     si
                inc     si
                mov     dx,cs:[si]
                inc     si
                inc     si
                mov     ax,_DAUA
                and     al,00000011b
                or      ax,5530h        ; DA/UA = 3xh
                int     1Bh
                JNC     NoDiskError
                inc     cs:DiskError       ; error counter
NoDiskError:    
                pop     cx
                add     BP,9216 ; adrv 9KB
                loop    load_CHRN_base
               pop     bp
                xor     ax,ax           ; success
                cmp     cs:DiskError,0
                je      WriteBuf_Cyl77_End
                mov     ax,cs:DiskError ; fail
WriteBuf_Cyl77_End:
                pop     di
                pop     si
                pop     es
                ret
DiskError       DW      0
;  ItZbg     CH3 CLV_  DHwbhDLZN^
;    BX=9216,     CX     DX     BlockSize
CHRN_base       label   word
        DW      024Dh,  0101h  ; 1
        DW      024Eh,  0001h  ; 2
        DW      024Eh,  0101h  ; 3
        DW      024Fh,  0001h  ; 4
        DW      024Fh,  0101h  ; 5
WriteBuf_Cyl77_1440  ENDP

;-----------------------------------------------------------------
;       ReadBuf_LastSect_1440
;-----------------------------------------------------------------
                PUBLIC  ReadBuf_LastSect_1440
ReadBuf_LastSect_1440   PROC   near     Buf512:WORD
                push    es
                push    si
                push    di

                mov     cs:DiskError,0
                mov     si,offset CHRN_base
               PUSH    BP
                les     bp,_DiskBuf
                mov     bx,512          ; len=0.5KB
                mov     cx,024Fh        ; 512B/s,cyl 4F 
                mov     dx,0112h        ; side 1, sect 18=12h
                mov     ax,_DAUA
                and     al,00000011b
                or      ax,5630h
                int     1Bh
               POP      BP
                JNC     @f
                inc     cs:DiskError    ; error counter
                shr     ax,8            ; error code
                and     al,0F0h
                jmp     ReadBuf_LastSect_1440_End
        @@:     
                mov     di,Buf512
                PUSH    DS
                push    ds
                pop     es      ; ES=DS
                lds     si,_DiskBuf
                mov     cx,0200h/2      ; 0.5KB
        rep     movsw
                POP     DS
                xor     ax,ax
                jmp     ReadBuf_LastSect_1440_End
ReadBuf_LastSect_1440_End:
                pop     di
                pop     si
                pop     es
                ret
ReadBuf_LastSect_1440  ENDP




END
