;   OS FD-IPLware ̃VXe (C) 2023 ܂
;   i[ł CS:IP 7400:0000 Ƀ[hs. 

APP_SEG         equ     6000h   ; HDIPLwareƓ
FDBOOT_SEG      equ     1FC0h
STACK_SIZE      equ    0F800h; X^bN̏Ԓni62KBɂĂj
L_COLUMN        equ     24      ; \Jʒui[O`j
L_ROW           equ     19      ; \sʒui[Q`QQj
XCHG_ROW        equ     23      ; 
MAX_APP_TABLE   equ     15
SHIFT_KEY       equ     1
OPE_MANUAL      equ     01h
OPE_CANCEL      equ     02h
OPE_OSBOOT      equ     08h
OPE_NOEXEC      equ     20h
COM_TYPE        equ     40h

PUSHA           macro   
                push    ax
                push    bx
                push    cx
                push    dx
                push    si
                push    di
endm
POPA            macro
                pop     di
                pop     si
                pop     dx
                pop     cx
                pop     bx
                pop     ax
endm

.8086
code            segment
                assume cs:code, ds:code, es:code, ss:code
        ORG   0h
start:          JMP     CodeStart       ; (3)
MaxAppNum       DB      MAX_APP_TABLE   ; (8)
EndOfCodeArea   DW      offset EndSignature1
TypeFlag        DB      40h     ; Avtype COM`^BIN`(RETFEo), 
ChkSum          DB      0       ; Avcheck sum byte
SegTVRAM        DW      0A000h
OpeMode         DB      0
AppNumber       DB      0
NoBeep          DB      0
BootDAUA        DB      90h
WaitCount       DW      0EEEEh
align 16
TabelBase       label   word         ; sum,  cond
                DB    "FDIPLAPP"  ,     0,    00h
                DW      1,  AppCode01-(00h),  0
                DB    "IPLAPP02"  ,     0,    40h
                DW      9,  AppCode02-(00h),  0
                DB    "NOEXEC03"  ,     0,   060h       ; no exec
                DW      9,  AppCode03-(00h),  0
                DB    "XYZ01234"  ,     0,   040h       ; 
                DW      9,  AppCode03-(00h),  0
                DB      8  dup (0),     0,    0
                DW      0,      0,      0       
                DB      8  dup (0),     0,    0
                DW      0,      0,      0       
                DB      0,0,0,0,0,0,0,0,  0,0
                DW      0,      0,      0
                DB      0,0,0,0,0,0,0,0,  0,0
                DW      0,      0,      0
                DB      0,0,0,0,0,0,0,0,  0,0
                DW      0,      0,      0
                DB      6*16 dup (0)
                ;   code size, offset word, dummy 0

CodeStart:      ; (org 100h)
; ɗ CS=5000h, DS=5000h, SS=????h, SP=FF??h
                PUSHA
                push    ds
                push    es
                
                mov     ax,cs
                mov     ds,ax   ; DS=CS ɍ킹
                xor     ax,ax
                mov     es,ax
                mov     al,es:[0584h]
                mov     BootDAUA,al
                mov     al,es:[0501h]
                test    al,8
                jz      @f
                mov     SegTVRAM,0E000h
        @@:     

                mov     ah,3
                int     18h
                
                mov     al,OpeMode
                test    al,al
                jz      @f
                call    ShortBeep0
        @@:
                test    OpeMode,OPE_CANCEL
                jnz     BootFromDev

                mov     AppNumber,0
ScanTableEntry: mov     ah,0
                mov     al,AppNumber
                shl     al,1
                shl     al,1
                shl     al,1
                shl     al,1
                mov     si,offset TabelBase
                add     si,ax       ; si= item of the app table

                push    si
                mov     dx,0E120h
                mov     ah,16h
                int     18h
                mov     si,offset MsgLoading
                mov     es,SegTVRAM
                mov     dl,0E5h    ; \FAgr[g
                mov     di, ( (XCHG_ROW-1)*80+L_COLUMN)*2        ; 12L,14C
                mov     cx,( offset MsgLoading_E - offset MsgLoading )/2
        @@:     mov     es:[di+2000h],dl
                movsw
               loop     @b
                pop     si

                call    ScanTable   ; return value AX=addr, BX=size
                jc      AppNoExec
                call    ExecApp     ; input  AX=addr, BX=size
                call    WaitShiftKey
AppNoExec:      
                inc     AppNumber
                cmp     AppNumber,MAX_APP_TABLE   ; max file number < 4
                jb      ScanTableEntry
BootFromDev:    
                call    MemSwBootFD
                jc      BootThisOSloader

                call    ShortBeep
                call    BootReady       ; u[gI
Cancel_all:

                test    OpeMode,OPE_OSBOOT
                jz      Cancel_OSBOOT

BootThisOSloader:
                mov     dx,0E120h
                mov     ah,16h          ; eLXgʏ
                int     18h

                mov     es,SegTVRAM
                mov     si,offset MsgLoadingDOS
                mov     dl,0E5h ; FAgr[g
                mov     di, ( 13*80+12 )*2
                mov     cx,( offset MsgLoadingDOS_E - offset MsgLoadingDOS  )/2
        @@:     mov     es:[di+2000h],dl
                movsw
               loop     @b

; Original FD OS(DOS)u[g   ; ES=CS=1FC0h, DS=0000h, SS=
                mov     es,cs:SegFDBOOT
                xor     ax,ax
                mov     di,ax
                mov     si,offset DOSFDIPL
                mov     cx,1024
        rep     movsb           ; copy restored original IPL
                mov     ds,ax   ; DS=0
                DB      9Ah     ; call far 1FC0:0000 ,execute the IPL
                DW      0
SegFDBOOT       DW      FDBOOT_SEG

Cancel_OSBOOT:
                pop     es      ; may not executed after this point
                pop     ds
                POPA
                RETF            ; dummy (may not executed)

SP_save         DW      0       ; [JX^bN̕ۑꏊ
SS_save         DW      0

;=======================================
ScanTable       PROC   near     ; SI= line top
                lodsw
                or      ax,ax
                jz      AppNoExist
                dec     si
                dec     si
                mov     es,SegTVRAM     ; display app name
                mov     di, ( (XCHG_ROW-1)*80+54)*2
                mov     cx, 8
        @@:     mov     byte ptr es:[di+2000h],0E1h ; FAgr[g
                movsb   ; LOWER BYTE
                mov     al,0
                stosb   ; HIGHER BYTE=0 (ANK only)
               loop     @b
               
                lodsw   ; flags
                mov     ChkSum,al
                mov     TypeFlag,ah
                lodsw   ; byte size
                or      ax,ax
                jz      AppNoExist      ; file byte size = 0 
                test    TypeFlag,OPE_NOEXEC
                jnz     AppNoExist      ; NOEXEC bit=1 (test 20h)
                test    OpeMode,OPE_MANUAL
                jz      @f
                call    YesNO
                jc      AppNoExist
        @@:     
                mov     bx,ax           ; bx=file byte size
                lodsw
                mov     dx,ax
                clc                     ; return ax=start offset
                ret
AppNoExist:     xor     ax,ax
                mov     bx,ax           ; return 0:0
                stc
                ret
ScanTable       ENDP
;---------------------------------------
ExecApp         PROC   near     ; [_s    bx=file size, ax=start offset 
                mov     di,0100h ; COM type program offset
                mov     si,ax   ; start offset of exec code
                mov     cx,bx   ; bx=file byte size 
                mov     ax,APP_SEG
                mov     es,ax   ; ES=APP_SEG
        rep     movsb
                xor     ax,ax
                mov     bx,ax
                mov     di,ax   ; DI=BX=0
                not     ax      ; AX=FFFFh
                mov     dx,ax   ; DX=CX=FFFFh
                mov     cx,ax   ; fBXNANZXs
                mov     si,0300h ; IPLware version 3.00 
                mov     cs:SP_save,sp
                mov     cs:SS_save,ss
                mov     ax,es
                cli
                mov     sp,STACK_SIZE
                mov     ss,ax   ; SS=6000h
                sti
                mov     bp,sp
                test    TypeFlag,COM_TYPE               ; bit 6 1=type 2(COM)
                mov     ds,ax   ; DS=ES=SS=6000h        ; Ver. 3.00
                mov     ax,0090h  ; DA/UA of 2HD FDD    ; Ver. 3.00
                jz      type1
type2: ;sJn (COM)
                mov     word ptr es:[00FCh],01E8h   ; 6000:00FC`00FFh
                mov     word ptr es:[00FEh],0CB00h  ; call 0100h,retf
                DB      9Ah             ; call far 6000:00FCh  
                DW      00FCh           ; 00FCh 
                DW      APP_SEG      ; 6000h
                jmp     UserProgramTerminated
type1: ;sJn (BIN)
                DB      9Ah             ; call far 6000:0100h  
                DW      0100h           ; 0100h 
                DW      APP_SEG         ; 6000h
UserProgramTerminated:  ;   RETFłɖ߂ė
                cli
                mov     sp,cs:SP_save
                mov     ss,cs:SS_save
                sti     
                mov     ax,cs
                mov     ds,ax
                mov     es,ax
                ; app name\
                mov     ax,0020h
                mov     es,SegTVRAM
                mov     dl,0E1h    ; \FAgr[g
                mov     di, ( (1+XCHG_ROW-1)*80+L_COLUMN)*2        ; 12L,14C
                mov     cx,8
        @@:     mov     es:[di+2000h],dl
                stosw
               loop     @b
                ret
ExecApp         ENDP

;---------------------------------------
YesNO           PROC   near
                push    es
                push    di
                push    si
                push    cx
                push    ax
                
                mov     es,SegTVRAM
                mov     si,offset MsgInq
                mov     di, ( (XCHG_ROW)*80+54)*2
                mov     cx,( offset MsgInq_E - offset MsgInq )/2
        @@:     mov     byte ptr es:[di+2000h],0E3h  ; \F
                movsw
               loop     @b
KeyReent:
                call    ShortBeep0
                xor     ax,ax
                int     18h
                cmp     ah,15h  ;[Y] pressed
                je      AnswerYes
                cmp     ah,2Eh  ;[N] pressed
                jne     KeyReent
                stc
                jmp     AnserNo
AnswerYes:      clc
AnserNo:
                pop     ax
                pop     cx
                pop     si
                pop     di
                pop     es
                ret
YesNO           ENDP

;---------------------------------------
BootReady       PROC   near
;FDbZ[Ws\
                mov     al,085h ; backgraound Agr[g
                call    ClrAttrArea;
                mov     es,SegTVRAM

                mov     si,offset MsgExchangeFD
                mov     dl,0C3h    ; \FAgr[g
                mov     di, ( XCHG_ROW*80+2)*2        ; 22L,10C
                mov     cx,( offset MsgExchangeFD_E - offset MsgExchangeFD )/2
        @@:     mov     es:[di+2000h],dl
                movsw
               loop     @b

                mov     si,offset MsgDevF
                mov     dl,085h ; FAgr[g
                mov     di, ( (-1+XCHG_ROW)*80+22)*2
                mov     cx,( offset MsgDevF_E - offset MsgDevF )/2
        @@:     mov     es:[di+2000h],dl
                movsw
               loop     @b

                mov     si,offset MsgDevH
                mov     dl,085h ; FAgr[g
                mov     di, ( (1+XCHG_ROW)*80+14)*2
                mov     cx,( offset MsgDevH_E - offset MsgDevH )/2
        @@:     mov     es:[di+2000h],dl
                movsw
               loop     @b

;            H1IDE#1,2IDE#2,SSCSI,MMO,BROM BASICbootv
                mov     al,0A5h
                mov     di,2000h+(-1+XCHG_ROW)*80*2
                mov     es:[42*2+di],al
                mov     di,2000h+(1+XCHG_ROW)*80*2
                mov     es:[14*2+di],al
                mov     es:[17*2+di],al
                mov     es:[26*2+di],al
                mov     es:[35*2+di],al
                mov     es:[43*2+di],al
                mov     es:[49*2+di],al


; L[҂
KeyEnter2:      
                xor     ax,ax
                int     18h
                cmp     ah,00h  ; [ESC]L[ꂽ
                je      ExitBootReady
                cmp     ah,34h  ; [SPACE]L[ꂽ
                je      NbootAll
                cmp     ah,2Dh  ; [B]L[ꂽ-->N88 ROM BASIC 
                je      NbootROMBASIC
                cmp     ah,22h  ; [H]L[ꂽ-->IDE#1N
                je      NbootSASI
                cmp     ah,1Dh  ; [A]L[ꂽ-->IDE#1N
                je      NbootSASI
                cmp     ah,01h  ; [1]L[ꂽ-->IDE#1N
                je      NbootSASI
                cmp     ah,02h  ; [2]L[ꂽ-->IDE#2N
                je      NbootSASI2
                cmp     ah,1Eh  ; [S]L[ꂽ-->SCSIN
                je      NbootSCSI
                cmp     ah,20h  ; [F]L[ꂽ-->FD2HDN
                je      NbootFD2HD
                cmp     ah,2Fh  ; [M]L[ꂽ-->MON
                je      NbootMO
                cmp     ah,1Ch  ; [s]L[ꂽ 
                je      FD_DOS_BOOT
                call    ShortBeep
                jmp     KeyEnter2

; ; Ux 1990N2 pp37-43  ALAH܂ł̃foCXTH
NbootROMBASIC:  mov     ax,0000h
                DB      0EAh            ; 2022-7-17 ver. 3.1
                DW      0000h
                DW      0E800h          ; jmp far E800:0000
NbootFD2HD:     mov     ax,0801h
                jmp     DiskBoot
NbootSASI:      mov     ax,0A0Ah
                jmp     DiskBoot
NbootSASI2:     mov     ax,0B0Bh
                jmp     DiskBoot
NbootSCSI:      mov     ax,0C0Ch
                jmp     DiskBoot
NbootMO:        mov     ax,0E0Eh        ; 2022-5-20 
                jmp     DiskBoot
NbootAll:       mov     ax,0C01h        ; AH=0C(SCSI), AL=01(FDD-2HD)

DiskBoot:       
                push    ax
                mov     dx,0E120h
                mov     ah,16h          ; eLXgʏ
                int     18h
                xor     ax,ax
                mov     ds,ax           ; DS=0ɂ !!!!!!
                pop     ax
                test    byte ptr ds:[0501h],8
                jnz     HiresoBoot
                DB  0EAh,0E8h,27h,80h,0FDh ; m[}[h ecu[gFD80:27E8 
HiresoBoot:
                DB  0EAh,0ECh,7Fh,00h,0F8h ; nC] u[gF800:7FECh
;====================== ŃfBXNu[gɔ==============
FD_DOS_BOOT:    or      OpeMode,OPE_OSBOOT
ExitBootReady:    ; ߂
                call    ShortBeep
                clc
                RET     ; ߂
BootReady       ENDP

;---------------------------------------------
;       MemSwBootFD     CY=fourced boot FD
;---------------------------------------------
MemSwitch5      equ     3FF2h
MemSwBootFD     PROC   near
                push    es
                xor     ax,ax
                mov     es,ax
                mov     ah, es:[0501h]
                mov     es,SegTVRAM
                mov     al,es:[MemSwitch5]
                pop     es
                test    ah,8
                jnz     BootFD_H
                and     al,11110000b
                cmp     al,20h  ; 640KB FD
                je      ForcedBootFD
                cmp     al,40h  ; 1MB FD
                je      ForcedBootFD
                jmp     NoForcedFD
BootFD_H:       or      al,al
                jz      ForcedBootFD
NoForcedFD:     clc
                ret
ForcedBootFD:   stc
                ret
MemSwBootFD    ENDP

;---------------------------------------
ShortBeep0:     mov     cx,222h
                jmp     Beep00
ShortBeep:      mov     cx,666h
                jmp     Beep00

LongBeep        PROC   near
                mov     cx,6666h
Beep00:
                push    ax
                mov     al,cs:NoBeep
                or      al,al
                jnz     EndBeep
                mov     al,6h
                out     37h,al
          @@:   out     5Fh,al
                out     5Fh,al
                out     5Fh,al
               loop     @b
                mov     al,7h
                out     37h,al
EndBeep:
                pop     ax
                ret
LongBeep        ENDP
;---------------------------------------
WaitShiftKey          PROC   near
                push    cx
                mov     cx,WaitCount
        @@:     out     5Fh,al
                out     5Fh,al
                out     5Fh,al
                out     5Fh,al
                out     5Fh,al
               loop     @b
                mov     al,7
                out     37h,al
Retry:          mov     ah,02h
                int 18h
                test    al,SHIFT_KEY
                jnz     Retry
                pop     cx
                ret
WaitShiftKey          ENDP
;---------------------------------------
ClrAttrArea     PROC   near     ; input al=attribute code
                mov     es,SegTVRAM
                mov     di,(XCHG_ROW-1)*80*2
                mov     cx,80*3
                mov     dl,al
                mov     ax,0020h
         @@:    
                mov     es:[di+2000h],dl
                stosw
               loop @b
                ret
ClrAttrArea     ENDP
;---------------------------------------
;;;us܂H(y/n)v
MsgInq  label byte
  DW  421Ch,429Ch,5419h,5499h,3704h,3784h,5E04h,5E84h,3904h,3984h
  DW  2B04h,2B84h,2901h,2981h,0028h,0079h,002Fh,006Eh,0029h,0000h
MsgInq_E  label byte

;;;u@@@̂܂ENTERL[ƁC̃tbs[fBXN̂nrN܂@@v
MsgExchangeFD label byte
  DW  2101h,2181h,2101h,2181h,3D04h,3D84h,4E04h,4E84h,5E04h,5E84h
  DW  5E04h,5E84h,0045h,004Eh,0054h,0045h,0052h,2D05h,2D85h,3C01h,3C81h,7204h
  DW  7284h,2112h,2192h,3904h,3984h,4804h,4884h,2401h,2481h,3304h,3384h,4E04h
  DW  4E84h,5505h,5585h,6D05h,6D85h,4305h,4385h,5405h,5485h,3C01h,3C81h,4705h
  DW  4785h,2305h,2385h,3905h,3985h,2F05h,2F85h,4E04h,4E84h,4F03h,4F83h,5303h
  DW  5383h,7204h,7284h,2F15h,2F95h,3026h,30A6h,3704h,3784h,5E04h,5E84h,3904h
  DW  3984h,2101h,2181h,2101h,2181h,0000h
MsgExchangeFD_E label byte

MsgDevF label byte
;;;uިĂ F FDbootv
  DW  00C3h,00DEh,00A8h,00BDh,00B8h,7204h,7284h,7218h,7298h,3914h,3994h,3704h
  DW  3784h,4604h,4684h,2B04h,2B84h,6904h,6984h,0020h,0046h,0020h,4704h,4784h
  DW  0046h,0044h,2B04h,2B84h,6904h,6984h,0062h,006Fh,006Fh,0074h,0000h
MsgDevF_E label byte

;;;uH1IDE#1,2IDE#2,SSCSI,MMO,BROM BASICbootv
MsgDevH       label byte
  DW  0048h,2B04h,2B84h,0031h,4704h,4784h,0049h,0044h,0045h,0023h,0031h,002Ch
  DW  0032h,4704h,4784h,0049h,0044h,0045h,0023h,0032h,002Ch,0053h,4704h,4784h
  DW  0053h,0043h,0053h,0049h,002Ch,004Dh,4704h,4784h,004Dh,004Fh,002Ch,0042h
  DW  4704h,4784h,0052h,004Fh,004Dh,0020h,0042h,0041h,0053h,0049h,0043h,2B04h
  DW  2B84h,6904h,6984h,0062h,006Fh,006Fh,0074h
MsgDevH_E       label byte

;;;ũ݂tbs[fBXN̂nrNłEEEv
MsgLoadingDOS label byte
  DW  2101h,2181h
  DW  3D18h,3D98h,5F1Ah,5F9Ah,4E04h,4E84h,5505h,5585h,6D05h,6D85h,4305h,4385h
  DW  5405h,5485h,3C01h,3C81h,4705h,4785h,2305h,2385h,3905h,3985h,2F05h,2F85h
  DW  651Eh,659Eh,4E04h,4E84h,4F03h,4F83h,5303h,5383h,7204h,7284h,2F15h,2F95h
  DW  3026h,30A6h,6623h,66A3h,4704h,4784h,3904h,3984h,2601h,2681h,2601h,2681h
  DW  2601h,2681h,0000h
MsgLoadingDOS_E label byte

MsgLoading       label   byte
;;;u FD-IPLwareع s v
  DW  0020h,0046h,0044h,002Dh,0049h,0050h,004Ch,0077h,0061h,0072h,0065h
  DW  00B1h,00CCh,00DFh,00D8h,00B9h,00B0h,00BCh,00AEh,00DDh,0020h,421Ch
  DW  429Ch,5419h,5499h,6623h,66A3h,0000h
MsgLoading_E     label   byte


;---------------------------------------
align 16
EndSignature1   DB      "FDIPLWARE SYSTEM"
EndSignature2   DB      "Application Base"
AppCode01:      RETF

AppCode02:      mov     al,06h
                out     37h,al
                mov     al,07h
                out     37h,al
                RET
AppCode03:      mov     al,06h
                out     37h,al
                mov     al,07h
                out     37h,al
                RET

DW      0,0,0,0
org     0C000h-1024
DOSFDIPL        label byte
if 0
   DB  0EBh,03Ch,090h,04Eh,045h,043h,020h,020h,035h,02Eh,030h,000h
   DB  004h,001h,001h,000h,002h,0C0h,000h,0D0h,004h,0FEh,002h,000h
   DB  008h,000h,002h,000h,000h,000h,000h,000h,000h,000h,000h,000h
   DB  080h,000h,029h,0FFh,00Eh,009h,018h,04Eh,04Fh,020h,04Eh,041h
   DB  04Dh,045h,020h,020h,020h,020h,046h,041h,054h,031h,032h,020h
   DB  020h,020h,033h,0C0h,08Eh,0D8h,08Eh,0C0h,08Eh,0D0h,0BCh,08Ah
   DB  002h,0FCh,0BEh,00Bh,000h,02Eh,0ADh,03Dh,000h,004h,074h,040h
   DB  02Eh,080h,07Ch,008h,0FBh,074h,039h,02Eh,080h,07Ch,008h,0F9h
   DB  074h,032h,0BEh,0B4h,001h,0B8h,000h,00Ah,0CDh,018h,0B4h,00Ch
   DB  0CDh,018h,0B4h,012h,0CDh,018h,00Eh,01Fh,0B4h,0A0h,026h,0F6h
   DB  006h,001h,005h,008h,074h,002h,0B4h,0E0h,08Eh,0C0h,0BFh,040h
   DB  001h,0ACh,00Ah,0C0h,074h,004h,0AAh,047h,0EBh,0F7h,0B0h,006h
   DB  0E6h,037h,0EBh,0FEh,0A0h,084h,005h,024h,0F0h,0BBh,000h,002h
   DB  0C7h,006h,002h,002h,005h,001h,0BAh,006h,000h,0C7h,006h,004h
   DB  002h,000h,008h,0C7h,006h,006h,002h,000h,010h,0B5h,002h,02Eh
   DB  080h,07Ch,008h,0F9h,075h,012h,03Ch,090h,074h,0A4h,0C7h,006h
   DB  002h,002h,006h,001h,0B2h,008h,0C7h,006h,006h,002h,000h,012h
   DB  0A8h,080h,074h,017h,0BBh,000h,004h,0C7h,006h,002h,002h,004h
   DB  001h,0C7h,006h,004h,002h,000h,014h,0C7h,006h,006h,002h,000h
   DB  020h,0B5h,003h,0BDh,000h,006h,0B1h,000h,0A0h,084h,005h,0E8h
   DB  05Fh,000h,01Eh,00Eh,01Fh,051h,0B9h,00Bh,000h,0BEh,0CEh,001h
   DB  0BFh,000h,006h,026h,0F6h,045h,00Bh,008h,074h,003h,083h,0C7h
   DB  020h,0F3h,0A6h,074h,008h,059h,01Fh,0BEh,0B4h,001h,0E9h,050h
   DB  0FFh,059h,01Fh,0BEh,000h,0F0h,0B4h,001h,08Bh,01Eh,004h,002h
   DB  08Bh,016h,002h,002h,0BDh,094h,019h,08Eh,0C5h,0BDh,060h,000h
   DB  089h,02Eh,000h,002h,033h,0FFh,0A0h,084h,005h,0E8h,019h,000h
   DB  0B2h,001h,0E8h,037h,000h,074h,00Dh,0E8h,00Fh,000h,0E8h,031h
   DB  000h,074h,005h,0E8h,007h,000h,0EBh,0EEh,0EAh,000h,000h,060h
   DB  000h,050h,0C6h,006h,008h,002h,00Ah,090h,0B4h,0D6h,0CDh,01Bh
   DB  073h,00Ch,0FEh,00Eh,008h,002h,074h,008h,0B4h,007h,0CDh,01Bh
   DB  0EBh,0EEh,058h,0C3h,058h,058h,0BEh,0C4h,001h,0E9h,0F1h,0FEh
   DB  0FEh,0C1h,080h,0F6h,001h,053h,050h,01Eh,08Eh,01Eh,000h,002h
   DB  026h,08Ah,046h,000h,045h,088h,005h,047h,075h,00Ch,036h,0C7h
   DB  006h,000h,002h,060h,010h,036h,08Eh,01Eh,000h,002h,04Bh,075h
   DB  0E7h,033h,0EDh,01Fh,058h,05Bh,02Bh,0F3h,080h,0DCh,000h,08Bh
   DB  01Eh,006h,002h,03Bh,0F3h,073h,006h,00Ah,0E4h,075h,002h,08Bh
   DB  0DEh,00Bh,0F6h,0C3h,04Eh,06Fh,020h,073h,079h,073h,074h,065h
   DB  06Dh,020h,066h,069h,06Ch,065h,073h,000h,049h,02Fh,04Fh,020h
   DB  065h,072h,072h,06Fh,072h,000h,049h,04Fh,020h,020h,020h,020h
   DB  020h,020h,053h,059h,053h,000h,0EBh,03Ch,090h,04Eh,045h,043h
   DB  020h,020h,035h,02Eh,030h,000h,000h,000h,001h,000h,002h,000h
   DB  000h,000h,000h,000h,000h,000h,000h,000h,000h,000h,000h,000h
   DB  000h,000h,000h,000h,000h,000h,000h,000h,000h,000h,000h,000h
   DB  000h,000h,000h,000h,000h,000h,000h,000h,000h,000h,000h,000h
   DB  000h,000h,000h,000h,000h,000h,000h,000h,033h,0C0h,08Eh,0D8h
   DB  08Eh,0C0h,08Eh,0D0h,0BCh,08Ah,002h,0FCh,0BEh,00Bh,000h,02Eh
   DB  083h,07Ch,00Dh,00Fh,074h,03Ah,02Eh,08Ah,044h,00Ah,03Ch,0F0h
   DB  074h,051h,0BEh,094h,001h,0B8h,000h,00Ah,0CDh,018h,0B4h,00Ch
   DB  0CDh,018h,0B4h,012h,0CDh,018h,00Eh,01Fh,0B4h,0A0h,026h,0F6h
   DB  006h,001h,005h,008h,074h,002h,0B4h,0E0h,08Eh,0C0h,0BFh,040h
   DB  001h,0ACh,00Ah,0C0h,074h,004h,0AAh,047h,0EBh,0F7h,0B0h,006h
   DB  0E6h,037h,0EBh,0FEh,02Eh,08Ah,044h,00Ah,03Ch,0F0h,075h,0C6h
   DB  0C7h,006h,002h,002h,00Fh,001h,0BAh,001h,001h,0C7h,006h,004h
   DB  002h,000h,002h,0C7h,006h,006h,002h,000h,01Eh,0EBh,015h,0C7h
   DB  006h,002h,002h,010h,001h,0BAh,002h,001h,0C7h,006h,004h,002h
   DB  000h,006h,0C7h,006h,006h,002h,000h,024h,0BBh,000h,002h,0B5h
   DB  002h,0BDh,000h,006h,0B1h,000h,0A0h,084h,005h,0E8h,05Fh,000h
   DB  01Eh,00Eh,01Fh,051h,0B9h,00Bh,000h,0BEh,0AEh,001h,0BFh,000h
   DB  006h,026h,0F6h,045h,00Bh,008h,074h,003h,083h,0C7h,020h,0F3h
   DB  0A6h,074h,008h,059h,01Fh,0BEh,094h,001h,0E9h,06Ah,0FFh,059h
   DB  01Fh,0BEh,000h,0F0h,0B4h,001h,08Bh,01Eh,004h,002h,08Bh,016h
   DB  002h,002h,0BDh,094h,019h,08Eh,0C5h,0BDh,060h,000h,089h,02Eh
   DB  000h,002h,033h,0FFh,0A0h,084h,005h,0E8h,019h,000h,0B2h,001h
   DB  0E8h,037h,000h,074h,00Dh,0E8h,00Fh,000h,0E8h,031h,000h,074h
   DB  005h,0E8h,007h,000h,0EBh,0EEh,0EAh,000h,000h,060h,000h,050h
   DB  0C6h,006h,008h,002h,00Ah,090h,0B4h,0D6h,0CDh,01Bh,073h,00Ch
   DB  0FEh,00Eh,008h,002h,074h,008h,0B4h,007h,0CDh,01Bh,0EBh,0EEh
   DB  058h,0C3h,058h,058h,0BEh,0A4h,001h,0E9h,00Bh,0FFh,0FEh,0C1h
   DB  080h,0F6h,001h,053h,050h,01Eh,08Eh,01Eh,000h,002h,026h,08Ah
   DB  046h,000h,045h,088h,005h,047h,075h,00Ch,036h,0C7h,006h,000h
   DB  002h,060h,010h,036h,08Eh,01Eh,000h,002h,04Bh,075h,0E7h,033h
   DB  0EDh,01Fh,058h,05Bh,02Bh,0F3h,080h,0DCh,000h,08Bh,01Eh,006h
   DB  002h,03Bh,0F3h,073h,006h,00Ah,0E4h,075h,002h,08Bh,0DEh,00Bh
   DB  0F6h,0C3h,04Eh,06Fh,020h,073h,079h,073h,074h,065h,06Dh,020h
   DB  066h,069h,06Ch,065h,073h,000h,049h,02Fh,04Fh,020h,065h,072h
   DB  072h,06Fh,072h,000h,049h,04Fh,020h,020h,020h,020h,020h,020h
   DB  053h,059h,053h,055h,08Bh,0ECh,056h,057h,0E9h,069h,006h,08Ah
   DB  046h,004h,0FEh,0C0h,0A2h,021h,069h,08Ah,046h,006h,0FEh,0C0h
   DB  0A2h,026h,069h,08Bh,046h,00Ah,0A3h,03Eh,069h,08Bh,046h,008h
   DB  03Dh,020h,080h,075h,003h,0EBh,07Dh,090h,03Dh,021h,080h,075h
   DB  003h,0E9h,05Ah,001h,03Dh,022h,080h,075h,003h,0E9h,081h,002h
   DB  006h,0B8h,040h,000h,08Eh,0C0h,026h,0A0h,084h,001h,0A2h,01Ch
   DB  069h,0BEh,004h,02Ah,026h,0C4h,034h,083h,0C6h,01Ch,026h,0ACh
   DB  0A2h,01Dh,069h,026h,0ACh,0A2h,01Eh,069h,026h,0ACh,0A2h,01Fh
   DB  069h,007h,0C6h,006h,032h,069h,000h,0A0h,021h,069h,0E8h,03Dh
   DB  004h,073h,016h,080h
endif

org     0C000h-2
DW      0
;-------------ȍ~ɋLqĂ͂ȂȂ------------
code    ends
        end start
END
