;   OS FD-IPLware ̃VXe for 1.44MB FD (C) 2023 ܂
;   i[ł CS:IP 7400:0000 Ƀ[hs. 

APP_SEG         equ     6000h   ; HDIPLwareƓ
FDBOOT_SEG      equ     1FE0h
STACK_SIZE      equ    0F800h; X^bN̏Ԓni62KBɂĂj
L_COLUMN        equ     24      ; \Jʒui[O`j
L_ROW           equ     19      ; \sʒui[Q`QQj
XCHG_ROW        equ     23      ; 
MAX_APP_TABLE   equ     15
SHIFT_KEY       equ     1
OPE_MANUAL      equ     01h
OPE_CANCEL      equ     02h
OPE_OSBOOT      equ     08h
OPE_NOEXEC      equ     20h
COM_TYPE        equ     40h

PUSHA           macro   
                push    ax
                push    bx
                push    cx
                push    dx
                push    si
                push    di
endm
POPA            macro
                pop     di
                pop     si
                pop     dx
                pop     cx
                pop     bx
                pop     ax
endm

.8086
code            segment
                assume cs:code, ds:code, es:code, ss:code
        ORG   0h
start:          JMP     CodeStart       ; (3)
MaxAppNum       DB      MAX_APP_TABLE   ; (8)
EndOfCodeArea   DW      offset EndSignature1
TypeFlag        DB      40h     ; Avtype COM`^BIN`(RETFEo), 
ChkSum          DB      0       ; Avcheck sum byte
SegTVRAM        DW      0A000h
OpeMode         DB      0
AppNumber       DB      0
NoBeep          DB      0
BootDAUA        DB      30h
WaitCount       DW      0EEEEh
align 16
TabelBase       label   word         ; sum,  cond
                DB    "FDIPLAPP"  ,     0,    00h
                DW      1,  AppCode01-(00h),  0
                DB    "IPLAPP02"  ,     0,    40h
                DW      9,  AppCode02-(00h),  0
                DB    "NOEXEC03"  ,     0,   060h       ; no exec
                DW      9,  AppCode03-(00h),  0
                DB    "XYZ01234"  ,     0,   040h       ; 
                DW      9,  AppCode03-(00h),  0
                DB      8  dup (0),     0,    0
                DW      0,      0,      0       
                DB      8  dup (0),     0,    0
                DW      0,      0,      0       
                DB      0,0,0,0,0,0,0,0,  0,0
                DW      0,      0,      0
                DB      0,0,0,0,0,0,0,0,  0,0
                DW      0,      0,      0
                DB      0,0,0,0,0,0,0,0,  0,0
                DW      0,      0,      0
                DB      6*16 dup (0)
                ;   code size, offset word, dummy 0

CodeStart:      ; (org 100h)
; ɗ CS=5000h, DS=5000h, SS=????h, SP=FF??h
                PUSHA
                push    ds
                push    es
                
                mov     ax,cs
                mov     ds,ax   ; DS=CS ɍ킹
                xor     ax,ax
                mov     es,ax
                mov     al,es:[0584h]
                mov     BootDAUA,al
                mov     al,es:[0501h]
                test    al,8
                jz      @f
                mov     SegTVRAM,0E000h
        @@:     

                call    wait1s
                xor     ax,ax
                out     0A8h,al
                out     0AAh,al
                out     0ACh,al
                out     0AEh,al

;L[`FbN ---
                in      al,41h  ; Status check 𖳎ăL[{[hǂ
                and     al,7Fh  ; make/break ꎋ
                cmp     al,39h  ; [DEL]Ȃ SpX
                je      CancelMode
                cmp     al,3Fh  ; [HELP] Ȃ ₢킹ɐݒ
                jne     EndOfKeyCheck
InqMode:        or      OpeMode,OPE_MANUAL
                jmp     EndOfKeyCheck
CancelMode:     or      OpeMode,OPE_CANCEL
EndOfKeyCheck:

                mov     ah,3
                int     18h
                
                mov     al,OpeMode
                test    al,al
                jz      @f
                call    ShortBeep0
        @@:
                test    OpeMode,OPE_CANCEL
                jnz     BootFromDev

                mov     AppNumber,0
ScanTableEntry: mov     ah,0
                mov     al,AppNumber
                shl     al,1
                shl     al,1
                shl     al,1
                shl     al,1
                mov     si,offset TabelBase
                add     si,ax       ; si= item of the app table

                push    si
                mov     dx,0E120h
                mov     ah,16h
                int     18h
                mov     si,offset MsgLoading
                mov     es,SegTVRAM
                mov     dl,0E5h    ; \FAgr[g
                mov     di, ( (XCHG_ROW-1)*80+L_COLUMN)*2        ; 12L,14C
                mov     cx,( offset MsgLoading_E - offset MsgLoading )/2
        @@:     mov     es:[di+2000h],dl
                movsw
               loop     @b
                pop     si

                call    ScanTable   ; return value AX=addr, BX=size
                jc      AppNoExec
                call    ExecApp     ; input  AX=addr, BX=size
                call    WaitShiftKey
AppNoExec:      
                inc     AppNumber
                cmp     AppNumber,MAX_APP_TABLE   ; max file number < 4
                jb      ScanTableEntry
BootFromDev:    
                call    MemSwBootFD
                jc      BootThisOSloader

                call    ShortBeep
                call    BootReady       ; u[gI
Cancel_all:

                test    OpeMode,OPE_OSBOOT
                jz      Cancel_OSBOOT

BootThisOSloader:
                mov     dx,0E120h
                mov     ah,16h          ; eLXgʏ
                int     18h

                mov     es,SegTVRAM
                mov     si,offset MsgLoadingDOS
                mov     dl,0E5h ; FAgr[g
                mov     di, ( 13*80+12 )*2
                mov     cx,( offset MsgLoadingDOS_E - offset MsgLoadingDOS  )/2
        @@:     mov     es:[di+2000h],dl
                movsw
               loop     @b

; Original FD OS(DOS)u[g   ; ES=CS=1FC0h, DS=0000h, SS=
                mov     es,cs:SegFDBOOT
                xor     ax,ax
                mov     di,ax
                mov     si,offset DOSFDIPL
                mov     cx,512  ; 512/1024
        rep     movsb           ; copy restored original IPL
                mov     ds,ax   ; DS=0
                DB      9Ah     ; call far 1FE0:0000 ,execute the IPL
                DW      0
SegFDBOOT       DW      FDBOOT_SEG

Cancel_OSBOOT:
                pop     es      ; may not executed after this point
                pop     ds
                POPA
                RETF            ; dummy (may not executed)

SP_save         DW      0       ; [JX^bN̕ۑꏊ
SS_save         DW      0

;=======================================
ScanTable       PROC   near     ; SI= line top
                cld
                lodsw
                or      ax,ax
                jz      AppNoExist
                dec     si
                dec     si
                mov     es,SegTVRAM     ; display app name
                mov     di, ( (XCHG_ROW-1)*80+54)*2
                mov     cx, 8
        @@:     mov     byte ptr es:[di+2000h],0E1h ; FAgr[g
                movsb   ; LOWER BYTE
                mov     al,0
                stosb   ; HIGHER BYTE=0 (ANK only)
               loop     @b
               
                lodsw   ; flags
                mov     ChkSum,al
                mov     TypeFlag,ah
                lodsw   ; byte size
                or      ax,ax
                jz      AppNoExist      ; file byte size = 0 
                test    TypeFlag,OPE_NOEXEC
                jnz     AppNoExist      ; NOEXEC bit=1 (test 20h)
                test    OpeMode,OPE_MANUAL
                jz      @f
                call    YesNO
                jc      AppNoExist
        @@:     
                mov     bx,ax           ; bx=file byte size
                lodsw
                mov     dx,ax
                clc                     ; return ax=start offset
                ret
AppNoExist:     xor     ax,ax
                mov     bx,ax           ; return 0:0
                stc
                ret
ScanTable       ENDP
;---------------------------------------
ExecApp         PROC   near     ; [_s    bx=file size, ax=start offset 
                mov     di,0100h ; COM type program offset
                mov     si,ax   ; start offset of exec code
                mov     cx,bx   ; bx=file byte size 
                mov     ax,APP_SEG
                mov     es,ax   ; ES=APP_SEG
        rep     movsb
                xor     ax,ax
                mov     bx,ax
                mov     di,ax   ; DI=BX=0
                not     ax      ; AX=FFFFh
                mov     dx,ax   ; DX=CX=FFFFh
                mov     cx,ax   ; fBXNANZXs
                mov     si,0300h ; IPLware version 3.00 
                mov     cs:SP_save,sp
                mov     cs:SS_save,ss
                mov     ax,es
                cli
                mov     sp,STACK_SIZE
                mov     ss,ax   ; SS=6000h
                sti
                mov     bp,sp
                test    TypeFlag,COM_TYPE               ; bit 6 1=type 2(COM)
                mov     ds,ax   ; DS=ES=SS=6000h        ; Ver. 3.00
                mov     ax,0090h  ; DA/UA of 2HD FDD    ; Ver. 3.00
                jz      type1
type2: ;sJn (COM)
                mov     word ptr es:[00FCh],01E8h   ; 6000:00FC`00FFh
                mov     word ptr es:[00FEh],0CB00h  ; call 0100h,retf
                DB      9Ah             ; call far 6000:00FCh  
                DW      00FCh           ; 00FCh 
                DW      APP_SEG      ; 6000h
                jmp     UserProgramTerminated
type1: ;sJn (BIN)
                DB      9Ah             ; call far 6000:0100h  
                DW      0100h           ; 0100h 
                DW      APP_SEG         ; 6000h
UserProgramTerminated:  ;   RETFłɖ߂ė
                cli
                mov     sp,cs:SP_save
                mov     ss,cs:SS_save
                sti     
                mov     ax,cs
                mov     ds,ax
                mov     es,ax
                ; app name\
                mov     ax,0020h
                mov     es,SegTVRAM
                mov     dl,0E1h    ; \FAgr[g
                mov     di, ( (1+XCHG_ROW-1)*80+L_COLUMN)*2        ; 12L,14C
                mov     cx,8
                cld
        @@:     mov     es:[di+2000h],dl
                stosw
               loop     @b
                ret
ExecApp         ENDP

;---------------------------------------
YesNO           PROC   near
                push    es
                push    di
                push    si
                push    cx
                push    ax
                
                mov     es,SegTVRAM
                mov     si,offset MsgInq
                mov     di, ( (XCHG_ROW)*80+54)*2
                mov     cx,( offset MsgInq_E - offset MsgInq )/2
        @@:     mov     byte ptr es:[di+2000h],0E3h  ; \F
                movsw
               loop     @b
KeyReent:
                call    ShortBeep0
                xor     ax,ax
                int     18h
                cmp     ah,15h  ;[Y] pressed
                je      AnswerYes
                cmp     ah,2Eh  ;[N] pressed
                jne     KeyReent
                stc
                jmp     AnserNo
AnswerYes:      clc
AnserNo:
                pop     ax
                pop     cx
                pop     si
                pop     di
                pop     es
                ret
YesNO           ENDP

;---------------------------------------
BootReady       PROC   near
;FDbZ[Ws\
                mov     al,085h ; backgraound Agr[g
                call    ClrAttrArea;
                mov     es,SegTVRAM

                mov     si,offset MsgExchangeFD
                mov     dl,0C3h    ; \FAgr[g
                mov     di, ( XCHG_ROW*80+2)*2        ; 22L,10C
                mov     cx,( offset MsgExchangeFD_E - offset MsgExchangeFD )/2
        @@:     mov     es:[di+2000h],dl
                movsw
               loop     @b

                mov     si,offset MsgDevF
                mov     dl,085h ; FAgr[g
                mov     di, ( (-1+XCHG_ROW)*80+22)*2
                mov     cx,( offset MsgDevF_E - offset MsgDevF )/2
        @@:     mov     es:[di+2000h],dl
                movsw
               loop     @b

                mov     si,offset MsgDevH
                mov     dl,085h ; FAgr[g
                mov     di, ( (1+XCHG_ROW)*80+14)*2
                mov     cx,( offset MsgDevH_E - offset MsgDevH )/2
        @@:     mov     es:[di+2000h],dl
                movsw
               loop     @b

;            H1IDE#1,2IDE#2,SSCSI,MMO,BROM BASICbootv
                mov     al,0A5h
                mov     di,2000h+(-1+XCHG_ROW)*80*2
                mov     es:[42*2+di],al
                mov     di,2000h+(1+XCHG_ROW)*80*2
                mov     es:[14*2+di],al
                mov     es:[17*2+di],al
                mov     es:[26*2+di],al
                mov     es:[35*2+di],al
                mov     es:[43*2+di],al
                mov     es:[49*2+di],al


; L[҂
KeyEnter2:      
                xor     ax,ax
                int     18h
                cmp     ah,00h  ; [ESC]L[ꂽ
                je      ExitBootReady
                cmp     ah,34h  ; [SPACE]L[ꂽ
                je      NbootAll
                cmp     ah,2Dh  ; [B]L[ꂽ-->N88 ROM BASIC 
                je      NbootROMBASIC
                cmp     ah,22h  ; [H]L[ꂽ-->IDE#1N
                je      NbootSASI
                cmp     ah,1Dh  ; [A]L[ꂽ-->IDE#1N
                je      NbootSASI
                cmp     ah,01h  ; [1]L[ꂽ-->IDE#1N
                je      NbootSASI
                cmp     ah,02h  ; [2]L[ꂽ-->IDE#2N
                je      NbootSASI2
                cmp     ah,1Eh  ; [S]L[ꂽ-->SCSIN
                je      NbootSCSI
                cmp     ah,20h  ; [F]L[ꂽ-->FD2HDN
                je      NbootFD2HD
                cmp     ah,2Fh  ; [M]L[ꂽ-->MON
                je      NbootMO
                cmp     ah,1Ch  ; [s]L[ꂽ 
                je      FD_DOS_BOOT
                call    ShortBeep
                jmp     KeyEnter2

; ; Ux 1990N2 pp37-43  ALAH܂ł̃foCXTH
NbootROMBASIC:  mov     ax,0000h
                DB      0EAh            ; 2022-7-17 ver. 3.1
                DW      0000h
                DW      0E800h          ; jmp far E800:0000
NbootFD2HD:     mov     ax,0801h
                jmp     DiskBoot
NbootSASI:      mov     ax,0A0Ah
                jmp     DiskBoot
NbootSASI2:     mov     ax,0B0Bh
                jmp     DiskBoot
NbootSCSI:      mov     ax,0C0Ch
                jmp     DiskBoot
NbootMO:        mov     ax,0E0Eh        ; 2022-5-20 
                jmp     DiskBoot
NbootAll:       mov     ax,0C01h        ; AH=0C(SCSI), AL=01(FDD-2HD)

DiskBoot:       
                push    ax
                mov     dx,0E120h
                mov     ah,16h          ; eLXgʏ
                int     18h
                xor     ax,ax
                mov     ds,ax           ; DS=0ɂ !!!!!!
                pop     ax
                test    byte ptr ds:[0501h],8
                jnz     HiresoBoot
                DB  0EAh,0E8h,27h,80h,0FDh ; m[}[h ecu[gFD80:27E8 
HiresoBoot:
                DB  0EAh,0ECh,7Fh,00h,0F8h ; nC] u[gF800:7FECh
;====================== ŃfBXNu[gɔ==============
FD_DOS_BOOT:    or      OpeMode,OPE_OSBOOT
ExitBootReady:    ; ߂
                call    ShortBeep
                clc
                RET     ; ߂
BootReady       ENDP

;---------------------------------------------
;       MemSwBootFD     CY=fourced boot FD
;---------------------------------------------
MemSwitch5      equ     3FF2h
MemSwBootFD     PROC   near
                push    es
                xor     ax,ax
                mov     es,ax
                mov     ah, es:[0501h]
                mov     es,SegTVRAM
                mov     al,es:[MemSwitch5]
                pop     es
                test    ah,8
                jnz     BootFD_H
                and     al,11110000b
                cmp     al,20h  ; 640KB FD
                je      ForcedBootFD
                cmp     al,40h  ; 1MB FD
                je      ForcedBootFD
                jmp     NoForcedFD
BootFD_H:       or      al,al
                jz      ForcedBootFD
NoForcedFD:     clc
                ret
ForcedBootFD:   stc
                ret
MemSwBootFD    ENDP

;---------------------------------------
ShortBeep0:     mov     cx,222h
                jmp     Beep00
ShortBeep:      mov     cx,666h
                jmp     Beep00

LongBeep        PROC   near
                mov     cx,6666h
Beep00:
                push    ax
                mov     al,cs:NoBeep
                or      al,al
                jnz     EndBeep
                mov     al,6h
                out     37h,al
          @@:   out     5Fh,al
                out     5Fh,al
                out     5Fh,al
               loop     @b
                mov     al,7h
                out     37h,al
EndBeep:
                pop     ax
                ret
LongBeep        ENDP
;---------------------------------------
WaitShiftKey          PROC   near
                push    cx
                mov     cx,WaitCount
        @@:     out     5Fh,al
                out     5Fh,al
                out     5Fh,al
                out     5Fh,al
                out     5Fh,al
               loop     @b
                mov     al,7
                out     37h,al
Retry:          mov     ah,02h
                int 18h
                test    al,SHIFT_KEY
                jnz     Retry
                pop     cx
                ret
WaitShiftKey          ENDP
;---------------------------------------
wait1s          PROC   near
                push    ax
                push    cx
                mov     cx,0FEDCh
          @@:   out     5Fh,al
                out     5Fh,al
                out     5Fh,al
                out     5Fh,al
               loop     @b
                pop     cx
                pop     ax
                ret
wait1s          ENDP
;---------------------------------------
ClrAttrArea     PROC   near     ; input al=attribute code
                cld
                mov     es,SegTVRAM
                mov     di,(XCHG_ROW-1)*80*2
                mov     cx,80*3
                mov     dl,al
                mov     ax,0020h
         @@:    
                mov     es:[di+2000h],dl
                stosw
               loop @b
                ret
ClrAttrArea     ENDP
;---------------------------------------
;;;us܂H(y/n)v
MsgInq  label byte
  DW  421Ch,429Ch,5419h,5499h,3704h,3784h,5E04h,5E84h,3904h,3984h
  DW  2B04h,2B84h,2901h,2981h,0028h,0079h,002Fh,006Eh,0029h,0000h
MsgInq_E  label byte

;;;u@@@̂܂ENTERL[ƁC̃tbs[fBXN̂nrN܂@@v
MsgExchangeFD label byte
  DW  2101h,2181h,2101h,2181h,3D04h,3D84h,4E04h,4E84h,5E04h,5E84h
  DW  5E04h,5E84h,0045h,004Eh,0054h,0045h,0052h,2D05h,2D85h,3C01h,3C81h,7204h
  DW  7284h,2112h,2192h,3904h,3984h,4804h,4884h,2401h,2481h,3304h,3384h,4E04h
  DW  4E84h,5505h,5585h,6D05h,6D85h,4305h,4385h,5405h,5485h,3C01h,3C81h,4705h
  DW  4785h,2305h,2385h,3905h,3985h,2F05h,2F85h,4E04h,4E84h,4F03h,4F83h,5303h
  DW  5383h,7204h,7284h,2F15h,2F95h,3026h,30A6h,3704h,3784h,5E04h,5E84h,3904h
  DW  3984h,2101h,2181h,2101h,2181h,0000h
MsgExchangeFD_E label byte

MsgDevF label byte
;;;uިĂ F FDbootv
  DW  00C3h,00DEh,00A8h,00BDh,00B8h,7204h,7284h,7218h,7298h,3914h,3994h,3704h
  DW  3784h,4604h,4684h,2B04h,2B84h,6904h,6984h,0020h,0046h,0020h,4704h,4784h
  DW  0046h,0044h,2B04h,2B84h,6904h,6984h,0062h,006Fh,006Fh,0074h,0000h
MsgDevF_E label byte

;;;uH1IDE#1,2IDE#2,SSCSI,MMO,BROM BASICbootv
MsgDevH       label byte
  DW  0048h,2B04h,2B84h,0031h,4704h,4784h,0049h,0044h,0045h,0023h,0031h,002Ch
  DW  0032h,4704h,4784h,0049h,0044h,0045h,0023h,0032h,002Ch,0053h,4704h,4784h
  DW  0053h,0043h,0053h,0049h,002Ch,004Dh,4704h,4784h,004Dh,004Fh,002Ch,0042h
  DW  4704h,4784h,0052h,004Fh,004Dh,0020h,0042h,0041h,0053h,0049h,0043h,2B04h
  DW  2B84h,6904h,6984h,0062h,006Fh,006Fh,0074h
MsgDevH_E       label byte

;;;ũ݂tbs[fBXN̂nrNłEEEv
MsgLoadingDOS label byte
  DW  2101h,2181h
  DW  3D18h,3D98h,5F1Ah,5F9Ah,4E04h,4E84h,5505h,5585h,6D05h,6D85h,4305h,4385h
  DW  5405h,5485h,3C01h,3C81h,4705h,4785h,2305h,2385h,3905h,3985h,2F05h,2F85h
  DW  651Eh,659Eh,4E04h,4E84h,4F03h,4F83h,5303h,5383h,7204h,7284h,2F15h,2F95h
  DW  3026h,30A6h,6623h,66A3h,4704h,4784h,3904h,3984h,2601h,2681h,2601h,2681h
  DW  2601h,2681h,0000h
MsgLoadingDOS_E label byte

MsgLoading       label   byte
;;;u FD-IPLwareع s v
  DW  0020h,0046h,0044h,002Dh,0049h,0050h,004Ch,0077h,0061h,0072h,0065h
  DW  00B1h,00CCh,00DFh,00D8h,00B9h,00B0h,00BCh,00AEh,00DDh,0020h,421Ch
  DW  429Ch,5419h,5499h,6623h,66A3h,0000h
MsgLoading_E     label   byte


;---------------------------------------
align 16
EndSignature1   DB      "FDIPLWARE SYSTEM"
EndSignature2   DB      "Application Base"
AppCode01:      RETF

AppCode02:      mov     al,06h
                out     37h,al
                mov     al,07h
                out     37h,al
                RET
AppCode03:      mov     al,06h
                out     37h,al
                mov     al,07h
                out     37h,al
                RET

DW      0,0,0,0
org     0B400h-512
DOSFDIPL        label byte
if 0
 DB 0EBh, 3Ch, 90h, 4Eh, 45h, 43h, 20h, 20h, 35h, 2Eh, 30h, 00h, 02h, 01h, 01h, 00h
 DB  02h,0E0h, 00h, 40h, 0Bh,0F0h, 09h, 00h, 12h, 00h, 02h, 00h, 00h, 00h, 00h, 00h
 DB  00h, 00h, 00h, 00h, 00h, 00h, 29h,0FBh, 1Eh, 09h, 17h, 4Eh, 4Fh, 20h, 4Eh, 41h
 DB  4Dh, 45h, 20h, 20h, 20h, 20h, 46h, 41h, 54h, 31h, 32h, 20h, 20h, 20h, 33h,0C0h
 DB  8Eh,0D8h, 8Eh,0C0h, 8Eh,0D0h,0BCh, 8Ah, 02h,0FCh,0BEh, 0Bh, 00h, 2Eh, 83h, 7Ch
 DB  0Dh, 0Fh, 74h, 3Ah, 2Eh, 8Ah, 44h, 0Ah, 3Ch,0F0h, 74h, 51h,0BEh, 94h, 01h,0B8h
 DB  00h, 0Ah,0CDh, 18h,0B4h, 0Ch,0CDh, 18h,0B4h, 12h,0CDh, 18h, 0Eh, 1Fh,0B4h,0A0h
 DB  26h,0F6h, 06h, 01h, 05h, 08h, 74h, 02h,0B4h,0E0h, 8Eh,0C0h,0BFh, 40h, 01h,0ACh
 DB  0Ah,0C0h, 74h, 04h,0AAh, 47h,0EBh,0F7h,0B0h, 06h,0E6h, 37h,0EBh,0FEh, 2Eh, 8Ah
 DB  44h, 0Ah, 3Ch,0F0h, 75h,0C6h,0C7h, 06h, 02h, 02h, 0Fh, 01h,0BAh, 01h, 01h,0C7h
 DB  06h, 04h, 02h, 00h, 02h,0C7h, 06h, 06h, 02h, 00h, 1Eh,0EBh, 15h,0C7h, 06h, 02h
 DB  02h, 10h, 01h,0BAh, 02h, 01h,0C7h, 06h, 04h, 02h, 00h, 06h,0C7h, 06h, 06h, 02h
 DB  00h, 24h,0BBh, 00h, 02h,0B5h, 02h,0BDh, 00h, 06h,0B1h, 00h,0A0h, 84h, 05h,0E8h
 DB  5Fh, 00h, 1Eh, 0Eh, 1Fh, 51h,0B9h, 0Bh, 00h,0BEh,0AEh, 01h,0BFh, 00h, 06h, 26h
 DB 0F6h, 45h, 0Bh, 08h, 74h, 03h, 83h,0C7h, 20h,0F3h,0A6h, 74h, 08h, 59h, 1Fh,0BEh
 DB  94h, 01h,0E9h, 6Ah,0FFh, 59h, 1Fh,0BEh, 00h,0F0h,0B4h, 01h, 8Bh, 1Eh, 04h, 02h
 DB  8Bh, 16h, 02h, 02h,0BDh, 94h, 19h, 8Eh,0C5h,0BDh, 60h, 00h, 89h, 2Eh, 00h, 02h
 DB  33h,0FFh,0A0h, 84h, 05h,0E8h, 19h, 00h,0B2h, 01h,0E8h, 37h, 00h, 74h, 0Dh,0E8h
 DB  0Fh, 00h,0E8h, 31h, 00h, 74h, 05h,0E8h, 07h, 00h,0EBh,0EEh,0EAh, 00h, 00h, 60h
 DB  00h, 50h,0C6h, 06h, 08h, 02h, 0Ah, 90h,0B4h,0D6h,0CDh, 1Bh, 73h, 0Ch,0FEh, 0Eh
 DB  08h, 02h, 74h, 08h,0B4h, 07h,0CDh, 1Bh,0EBh,0EEh, 58h,0C3h, 58h, 58h,0BEh,0A4h
 DB  01h,0E9h, 0Bh,0FFh,0FEh,0C1h, 80h,0F6h, 01h, 53h, 50h, 1Eh, 8Eh, 1Eh, 00h, 02h
 DB  26h, 8Ah, 46h, 00h, 45h, 88h, 05h, 47h, 75h, 0Ch, 36h,0C7h, 06h, 00h, 02h, 60h
 DB  10h, 36h, 8Eh, 1Eh, 00h, 02h, 4Bh, 75h,0E7h, 33h,0EDh, 1Fh, 58h, 5Bh, 2Bh,0F3h
 DB  80h,0DCh, 00h, 8Bh, 1Eh, 06h, 02h, 3Bh,0F3h, 73h, 06h, 0Ah,0E4h, 75h, 02h, 8Bh
 DB 0DEh, 0Bh,0F6h,0C3h, 4Eh, 6Fh, 20h, 73h, 79h, 73h, 74h, 65h, 6Dh, 20h, 66h, 69h
 DB  6Ch, 65h, 73h, 00h, 49h, 2Fh, 4Fh, 20h, 65h, 72h, 72h, 6Fh, 72h, 00h, 49h, 4Fh
 DB  20h, 20h, 20h, 20h, 20h, 20h, 53h, 59h, 53h, 55h, 8Bh,0ECh, 56h, 57h,0E9h, 69h
 DB  06h, 8Ah, 46h, 04h,0FEh,0C0h,0A2h, 21h, 69h, 8Ah, 46h, 06h,0FEh,0C0h,0A2h, 26h
 DB  69h, 8Bh, 46h, 0Ah,0A3h, 3Eh, 69h, 8Bh, 46h, 08h, 3Dh, 20h, 80h, 75h, 03h,0EBh
 DB  7Dh, 90h, 3Dh, 21h, 80h, 75h, 03h,0E9h, 5Ah, 01h, 3Dh, 22h, 80h, 75h, 03h,0E9h
 DB  81h, 02h, 06h,0B8h, 40h, 00h, 8Eh,0C0h, 26h,0A0h, 84h, 01h,0A2h, 1Ch, 69h,0BEh
endif
org     0B400h-2
DW      0
;-------------ȍ~ɋLqĂ͂ȂȂ------------
code    ends
        end start
END
