SLEN2048        equ     4
SLEN1024        equ     3
SLEN512         equ     2
SLEN256         equ     1
SLEN128         equ     0
DLEN8SECT       equ     8*4     

;--------------------------------------------------------------
;     Floppy I/O , memXfer Library  
;--------------------------------------------------------------
        Title   dskbio.s
                .186
                .MODEL  small,C
.data
extern          _DiskBuf:DWORD  ; ( byte pointer far)
extern          _DAUA:WORD      ; ( word pointer near)

CylNumber       DB      77      ; V_ԍ̕ϐ
HeadNumber      DB      0       ; TChiwbhj
CHRN8S          label   byte    ; ZN^p[^ 0 ̂Ƃ͕ϐ
                DB      0,0,1,0
                DB      0,0,2,0
                DB      0,0,3,0
                DB      0,0,4,0
                DB      0,0,5,0
                DB      0,0,6,0
                DB      0,0,7,0
                DB      0,0,8,0
MaxDrvNum       DW      26              ; hCu^[̍őiϐj
DAUA_newlist    DB      60h dup(0)      ; int DChŎgpwork area

.code

;---------------------------------------------------------------
;   WORD  GetListFDD(WORD *);  0=none, !0= number of FD devices
;---------------------------------------------------------------
                PUBLIC  GetListFDD      ; DA/UAdrive letteȓΏƕ\𓾂
GetListFDD      PROC   near     DrvLstPtr:WORD
                cld
                push    di
                push    si      
                push    es      ; ES:DI=DOS, DS:SI=DrvLstPtr
;;;JMP OldDOS
                mov     cl,12h  ; gDOC functiong
                xor     ax,ax   ; AX=0
                int     0DCh
                or      ax,ax   ; AXɌƓlԂ΋@\ver.
                jz      OldDOS  ; ÂDOS

                mov     cl,13h  ; ײޑΏƕ\𓾂
                mov     dx,offset DAUA_newlist
                int     0DCh
                push    ds
                pop     es      ; ES=DSɂ
                mov     di,offset DAUA_newlist
                mov     si,di
                add     si,001Ah        ; 26̕\̊JnItZbgʒu
                mov     cx,26   ; 26܂킷
        @@:     lodsw           ; [hœ
                xchg    al,ah   ; ւ
                stosb           ; DA/UAZbg
               loop     @b      ; ȏloop
                mov     bx,0
                mov     di,offset DAUA_newlist  ; bx+di[Ne[uւ̃|C^
                mov     si,DrvLstPtr    ; di葤Asi󂯑Ȃ̂ŒӁI
                jmp     ScanDAUA_ent    ; 
OldDOS:         ; ÂDOS̏ꍇA: P: ܂ł璼ɓ
                mov     MaxDrvNum,16    ; ÂDOSł͍ő16hCuɐ
                mov     si,DrvLstPtr    
                xor     ax,ax
                mov     bx,ax
                mov     cx,ax           ; bx=cx=0 ɏlZbg
                mov     di,006Ch        ; table offset
                mov     ax,0060h        ; DOS segment 2.11ς炸
                mov     es,ax           
ScanDAUA_ent:
                mov     al,es:[bx+di]   ; 葤
                test    al,10h          ; DA/UA bit 4 FDD ǂ̃tO
                jz      NotFDD 
                mov     ah,bl           ; blloopJE^ A:=0, B:=1,,,
                mov     ds:[si],ax      ; ʂɃhCuԍ,ʂDA/UA
                inc     si
                inc     si      ; 󂯑[hi߂ SI󂯂Ȃ̂ŒӁI
                inc     cx      ; ̃JE^FDDłꍇ̂ݑ
NotFDD:
                inc     bx
                cmp     bx,MaxDrvNum    ; BXőhCuɒB
                jb      ScanDAUA_ent    ; łԂloop

                mov     ax,cx   ; CX͌echCuiԒlj
                pop     es
                pop     si
                pop     di
                ret
GetListFDD      ENDP


;-----------------------------------------------------------------
;       ReadFDIPL  IPL̃ZN^ǂݏo 1232KB fBAp
;-----------------------------------------------------------------
                PUBLIC  ReadFDIPL
ReadFDIPL       PROC   near     BufPtrR:WORD
                push    es
                push    si
                push    di
                push    bp
                les     bp,_DiskBuf
                mov     ax,_DAUA
                or      ax,0790h        ; recalibrate
                int     1Bh

                les     bp,_DiskBuf
                mov     bx,0400h        ; data len=1024B
                mov     cx,0300h        ; sect len=1024B/s, cyl00
                mov     dx,0001h        ; side00,sect01
                mov     ax,_DAUA
                or      ax,5690h        ; READ sector
                int     1Bh
                pop     bp
                jc      ErrReadFDIPL

                push    ds
                mov     ax,ds
                mov     es,ax
                mov     di,BufPtrR
                lds     si,_DiskBuf
                mov     cx,1024/2
        rep     movsw
                pop     ds
                xor     ax,ax
                jmp     EndReadFDIPL
ErrReadFDIPL:   shr     ax,8            ; error code
                and     al,0F0h 
EndReadFDIPL:
                pop     di
                pop     si
                pop     es
                ret
ReadFDIPL       ENDP

;-----------------------------------------------------------------
;       WriteFDIPL  IPL̃ZN^ɏ 1232KB fBAp
;-----------------------------------------------------------------
                PUBLIC  WriteFDIPL
WriteFDIPL      PROC   near     BufPtrW7:WORD
                push    es
                push    si
                push    di

                mov     si,BufPtrW7
                les     di,_DiskBuf
                mov     cx,1024/2
        rep     movsw

                push    bp
                les     bp,_DiskBuf
                mov     ax,_DAUA
                or      ax,0790h        ; recalibrate
                int     1Bh
                mov     bx,0400h        ; data len=1024B
                mov     cx,0300h        ; sect len=1024B/s, cyl00
                mov     dx,0001h        ; side00,sect01
                mov     ax,_DAUA
                or      ax,5590h        ; WRITE sector
                int     1Bh
                pop     bp
                mov     ax,0
                jnc     @f
                shr     ax,8            ; error code
                and     al,0F0h
        @@:
                pop     di
                pop     si
                pop     es
                ret
WriteFDIPL      ENDP

;-----------------------------------------------------------------
;       WriteBuf_Cyl77  1232KB fBAp
;-----------------------------------------------------------------
                PUBLIC  WriteBuf_Cyl77  
WriteBuf_Cyl77  PROC   near     Buf48K:WORD
                push    es
                push    si
                push    di

                mov     cs:DiskError,0
                mov     si,Buf48K
                les     di,_DiskBuf
                mov     cx,0C000h/2
        rep     movsw
                mov     si,offset CHRN_base

               push    bp
                les     bp,_DiskBuf
                mov     cx,6            ; 6 blocks
load_CHRN_base: mov     bx,8192         ; len=8KB
                push    cx
                mov     cx,cs:[si]
                inc     si
                inc     si
                mov     dx,cs:[si]
                inc     si
                inc     si
                mov     ax,_DAUA
                or      ax,5590h
                int     1Bh
                JNC     NoDiskError
                inc     cs:DiskError       ; error counter
NoDiskError:    
                pop     cx
                add     BP,8192 ; adrv 8KB
                loop    load_CHRN_base
               pop     bp
                xor     ax,ax           ; success
                cmp     cs:DiskError,0
                je      WriteBuf_Cyl77_End
                mov     ax,cs:DiskError ; fail
WriteBuf_Cyl77_End:
                pop     di
                pop     si
                pop     es
                ret
DiskError       DW      0
;  ItZbg     CH3 CLV_  DHwbhDLZN^
;    BX=8192,     CX     DX     BlockSize
CHRN_base       label   word
        DW      034Dh,  0001h  ; 1
        DW      034Dh,  0101h  ; 2
        DW      034Eh,  0001h  ; 3
        DW      034Eh,  0101h  ; 4
        DW      034Fh,  0001h  ; 5
        DW      034Fh,  0101h  ; 6
WriteBuf_Cyl77  ENDP

;-----------------------------------------------------------------
;       ReadBuf_LastSect 1232KB fBAp
;-----------------------------------------------------------------
                PUBLIC  ReadBuf_LastSect
ReadBuf_LastSect   PROC   near     Buf1k:WORD
                push    es
                push    si
                push    di

                mov     cs:DiskError,0
                mov     si,offset CHRN_base
               PUSH    BP
                les     bp,_DiskBuf
                mov     bx,1024         ; len=1KB
                mov     cx,034Fh        ; 1024B/s,cyl 4F 
                mov     dx,0108h        ; side 1, sect 8
                mov     ax,_DAUA
                or      ax,5690h
                int     1Bh
               POP      BP
                JNC     @f
                inc     cs:DiskError    ; error counter
                mov     ax,0FFFFh
                jmp     ReadBuf_LastSect_End
        @@:     
                mov     di,Buf1k
                PUSH    DS
                push    ds
                pop     es      ; ES=DS
                lds     si,_DiskBuf
                mov     cx,0400h/2      ; 1KB
        rep     movsw
                POP     DS
                xor     ax,ax
                jmp     ReadBuf_LastSect_End
ReadBuf_LastSect_End:
                pop     di
                pop     si
                pop     es
                ret
ReadBuf_LastSect  ENDP

;-----------------------------------------------------------------
;       ReadBuf_Cyl77  1232KB fBAp
;-----------------------------------------------------------------
                PUBLIC  ReadBuf_Cyl77  
ReadBuf_Cyl77   PROC   near     Buf48k:WORD
                push    es
                push    si
                push    di
                
                call    Read_Cyl77

                xor     ax,ax           ; success
                cmp     cs:DiskError,0
                jne     ReadBuf_Cyl77_Err
                
                mov     di,Buf48k
                push    ds
                push    ds
                pop     es
                lds     si,_DiskBuf
                mov     cx,0C000h/2
        rep     movsw
                pop     ds
                xor     ax,ax
                jmp     ReadBuf_Cyl77_End
ReadBuf_Cyl77_Err:
                mov     ax,cs:DiskError ; fail
ReadBuf_Cyl77_End:
                pop     di
                pop     si
                pop     es
                ret
ReadBuf_Cyl77   ENDP

;-----------------------------------------------------------------
;       Read_Cyl77      private 1232KB fBAp
;-----------------------------------------------------------------
Read_Cyl77      PROC   near
                mov     cs:DiskError,0
                mov     si,offset CHRN_base
               push    bp
                les     bp,_DiskBuf
                mov     cx,6            ; 6 blocks
load_CHRN_base: mov     bx,8192         ; len=8KB
                push    cx
                mov     cx,cs:[si]
                inc     si
                inc     si
                mov     dx,cs:[si]
                inc     si
                inc     si
                mov     ax,_DAUA
                or      ax,5690h
                int     1Bh
                JNC     NoDiskErrorR
                and     ah,0F0h
                cmp     ah,60h
                jne     @f
                mov     cs:DiskError,60h
        @@:
                inc     cs:DiskError       ; error counter
NoDiskErrorR:    
                pop     cx
                add     BP,8192 ; adrv 8KB
                loop    load_CHRN_base
               pop     bp
                ret
Read_Cyl77      ENDP


;-----------------------------------------------------------------
;       FormatTrack77 -79 1232KB fBAp
;-----------------------------------------------------------------
                PUBLIC  FormatTrack77
FormatTrack77   PROC   near
                mov     CylNumber,77
                mov     HeadNumber,0
                call    FormatTrackCH
                jc      FormatFail
                mov     CylNumber,77
                mov     HeadNumber,1
                call    FormatTrackCH   
                jc      FormatFail
                mov     CylNumber,78
                mov     HeadNumber,0
                call    FormatTrackCH   
                jc      FormatFail
                mov     CylNumber,78
                mov     HeadNumber,1
                call    FormatTrackCH   
                jc      FormatFail
                mov     CylNumber,79
                mov     HeadNumber,0
                call    FormatTrackCH   
                jc      FormatFail
                mov     CylNumber,79
                mov     HeadNumber,1
                call    FormatTrackCH
                jc      FormatFail
                mov     cs:DiskError,0
                call    Read_Cyl77      ; ǂݏõ`FbN 1.25Œǉ
                cmp     cs:DiskError,0
                jne     FormatFail
                mov     ax,0    ; Ԓl, m[G[
                ret
FormatFail:     mov     ax,1    ; Ԓl, G[
                ret
FormatTrack77   ENDP

FormatTrackCH   PROC   near     ; 1232KB fBAp
                cld
                push    ds
                pop     es      ; ES=DS
                mov     cx,0
                mov     bx,DLEN8SECT
                mov     di, offset CHRN8S
SectDataLoop:   inc     cx              ; PW܂loop
                mov     al,CylNumber
                mov     ah,HeadNumber
                stosw
                mov     al,cl   ; sect #
                mov     ah,SLEN1024
                stosw
                cmp     cx,8
                jbe     SectDataLoop
                mov     ch,SLEN1024  ; sect leng
                mov     cl,CylNumber
                mov     dh,HeadNumber
                mov     dl,0E5h
                mov     bx,DLEN8SECT
                mov     ax,_DAUA
                or      al,90h
                mov     ah,0Dh  ; [Format Track]
                or      ah,01010000b
                push    bp
                mov     bp, offset CHRN8S
                int 1Bh
                pop     bp
                ret
FormatTrackCH   ENDP

;-----------------------------------------------------------------
;       fBXNI/Ô߂̃obt@m
;-----------------------------------------------------------------
        PUBLIC  AllocateDiskBuf 
AllocateDiskBuf PROC    near    ; No arguments
                cld
                push    es
                push    di
                mov     bx,2000h        ; paragraph size, 128KBm
                inc     bx
                mov     ax,4800h        ; ZOg𓾂
                int     21h
                jc      mem_err
                push    ax              ; ax=seg
                mov     es,ax           
                xor     ax,ax
                mov     di,ax
                mov     cx,32768        ; 64KB [ŏ
            rep stosw
                pop     ax              ; ax=seg
                and     ax,0F000h 
                add     ax, 1000h       ; 64KBEɂ
                mov     dx,ax           ; ZOgFOԂ
                xor     ax,ax
                mov     di,ax           ; di=0000,ax=0000
                mov     cx,32768        ; 64KB [ŏ
                mov     es,dx
            rep stosw
AllocateDiskBuf_end:
                pop     di
                pop     es
                ret
mem_err:        xor     ax,ax           ; G[̏ꍇ 0L (ulong NULL)Ԃ
                mov     dx,ax
                jmp     AllocateDiskBuf_end
AllocateDiskBuf ENDP

;-----------------------------------------------------------------
;       fn_memcpy      far to near Rs[  near1<--far2
;-----------------------------------------------------------------
               PUBLIC   fn_memcpy
fn_memcpy      PROC   near     membuf1:WORD , membuf2:DWORD , dlen:WORD
                cld           ; near             far
                push    es
                push    si
                push    di

                push    ds      ; es=ds
                pop     es
                mov     cx,dlen
                mov     di,membuf1
                push    ds
                lds     si,membuf2
        rep     movsb
                pop     ds

                pop     di
                pop     si
                pop     es
                ret
fn_memcpy      ENDP

if 0
;-----------------------------------------------------------------
;  nf_memcpy      near to farRs[  near1<--far2 (gp)
;-----------------------------------------------------------------
                PUBLIC  nf_memcpy      
nf_memcpy       PROC   near     membuf1:DWORD , membuf2:WORD , dlen:WORD
                cld           ; far    <--         near
                push    es
                push    si
                push    di

                mov     cx,dlen
                les     di,membuf1      ;
                mov     si,membuf2
          rep   movsb

                pop     di
                pop     si
                pop     es
                ret
;-----------------------------------------------------------------
nf_memcpy       ENDP
endif

;----------------------------------------------------------------------
;       YesNo   Y=0, N=1, ESC=2 ̃L[͂ԂȂ̂Ƃ͍Ďs
;----------------------------------------------------------------------
YesNo           PROC   near
YesNoEnt1:      xor     ax,ax
                int     18h
                cmp     ah,15h  ;'Y'
                je      CharYes
                cmp     ah,2Eh  ;'N'
                je      CharNo
                cmp     ah,00h  ;'ESC'
                je      CharNo2
                mov     cx,444h
                mov     al,6    ; x
                out     37h,al
        @@:     out     5Fh,al
                out     5Fh,al
               loop     @b      
                mov     al,7    ; beep~߂
                out     37h,al
                jmp     YesNoEnt1 ; Ďs
CharNo2:        mov     ax,2
                ret
CharNo:         mov     ax,1
                ret
CharYes:        mov     ax,0
                ret
YesNo           ENDP

; ȉDOSt@NVgp
;-----------------------------------------------------------------
;       MS-DOS file operation   
;-----------------------------------------------------------------
                PUBLIC  _open
_open           PROC    filename:WORD
                mov     dx,filename
                mov     ax,3D00h
                xor     bx,bx
                int 21h
                mov     cs:_doserrno,ax
                mov     ax,0FFFFh       ; ( -1 ) error
                jc      @f
                mov     ax,bx           ; (file handle) success
  @@:           ret
_open           ENDP

; ǂݏfunctionł G[ĂL[͗ɁACX菭Ȃ
; ݃oCgԂ. L[̂Ƃ̓[Ԃ̂悢. 

                PUBLIC  _read     ; :2far pointer
_read           PROC    ARG1:WORD, ARG2:DWORD, ARG3:WORD
                push    ds
                mov     bx,ARG1
                lds     dx,ARG2
                mov     cx,ARG3
                mov     ah,3Fh
                int     21h
                pop     ds
                jnc     @f
                mov     cs:_doserrno,ax
                xor     ax,ax   ; [
   @@:          ; L[ȂƂ͓ǂݍ݃oCgAX̂܂ܕԂ
                ret
_read           ENDP

IF 0    ; 񖢎gp
                PUBLIC  _write  ; :2far pointer
_write          PROC    ARG1:WORD, ARG2:DWORD, ARG3:WORD
                push    ds
                mov     bx,ARG1
                lds     dx,ARG2
                mov     cx,ARG3
                mov     ah,40h
                int     21h
                pop     ds
                jnc     @f
                mov     cs:_doserrno,ax
                xor     ax,ax   ; L[̂Ƃ̓[oCgԂ
       @@:      ; L[ȂƂ͏݃oCgAX̂܂ܕԂ
                ret     
_write          ENDP

                PUBLIC  _creat
_creat          PROC    filename:WORD
                mov     dx,filename
                mov     cx,0020h
                mov     ax,3C00h
                xor     bx,bx
                int     21h
                mov     cs:_doserrno,ax
                mov     ax,0FFFFh       ; (-1) error
                jc      @f
                mov     ax,bx           ; (file handle) success
   @@:          ret
_creat          ENDP

ENDIF

                PUBLIC  _close
_close          PROC    near    handle:WORD
                mov     bx,handle
                mov     ah,3Eh
                xor     dx,dx
                int     21h
                mov     cs:_doserrno,ax
                jc      @f
                xor     ax,ax
   @@:          ret
_close          ENDP

                PUBLIC  _filesize
_filesize       PROC  NEAR      handlez:WORD
                push    es
                mov     bx,handlez
                xor     cx,cx
                xor     dx,dx
                mov     ax,4202h        ; go to the end of file
                int 21h
                jc      no_file

                push    ax
                push    dx
                mov     bx,handlez
                xor     cx,cx
                xor     dx,dx
                mov     ax,4200h        ; rewind
                int 21h
                pop     dx
                pop     ax

                jmp     end_filesize
    no_file:    mov     ax,0FFFFh
                mov     dx,ax           ; (-1) error
end_filesize:   
                pop     es
                ret
_filesize       ENDP

_doserrno       DW      0

;΃pXassin/joinꂽpath{̖OɕϊiDOS̋@\60Hgpj
                PUBLIC  ConvAbsolutePath   
ConvAbsolutePath   PROC NEAR   RelName:WORD,   AbsName:WORD
                cld
                push    es
                push    si
                push    di

                push    ds
                pop     es      ; ES=DS

                mov     si,RelName      ; path܂ޕւ̃|C^
                mov     di,AbsName      ; pathɕϊ̊i[
                mov     ah,60h          ; DOSt@NV
                int     21h
;;;;;;;;        jnc     ExistFunc60h_DOS ; G[ԂƂ͖H
                mov     di,AbsName      ; functionT|[g
                mov     al,ds:[di]      ; ĂȂꍇ 擪
                or      al,al           ; nullł
                jnz     ExistFunc60h_DOS
                mov     si,RelName      
                mov     cx,0
CopyPathNameEntry:    ; T|[gÔƂ͂P̂܂܃Rs[
                lodsb   
                stosb
                or      al,al           ; NULL
                jz      ExistFunc60h_DOS
                inc     cx
                cmp     cx,266  ; NULL̏ꍇł\266oCg܂
                jae     ExistFunc60h_DOS
                jmp     CopyPathNameEntry
ExistFunc60h_DOS:
                mov     ax,AbsName      ; Ԓl DX:AX ܂ AX
                mov     dx,ds           ; far|C^Ԃłg悤
                pop     di
                pop     si
                pop     es
                ret
ConvAbsolutePath   ENDP

END
